
datablock WheeledVehicleData(coveredwagonVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./coveredwagon.dts"; //"~/data/shapes/skivehicle.dts"; //
	emap = true;
	minMountDist = 3;
   
   numMountPoints = 7;
   mountThread[0] = "sit";
   mountThread[1] = "sit";
   mountThread[2] = "root";
   mountThread[3] = "root";
   mountThread[4] = "root";
   mountThread[5] = "root";
   mountThread[6] = "sit";

	maxDamage = 150.00;
	destroyedLevel = 150.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0.7 0";
   //massBox = "2 5 1";

	maxSteeringAngle = 0.9785;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 9;         // Far distance from vehicle
	cameraOffset = 8;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = false;	

	// defaultTire	= coveredwagonTire;
	// defaultSpring	= coveredwagonSpring;
	// flatTire	= jeepFlatTire;
	// flatSpring	= jeepFlatSpring;

   //numWheels = 6;

	// Rigid Body
	mass = 200;
	density = 6.0;
	drag = 1.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 4000; //4000;       // Engine power
	engineBrake = 2000;         // Braking when throttle is 0
	brakeTorque = 2000;        // When brakes are applied
	maxWheelSpeed = 25;        // Engine scale by current speed / max speed

	rollForce		= 900;
	yawForce		= 600;
	pitchForce		= 1000;
	rotationalDrag		= 0.2;

	// Advanced Steering
   steeringAutoReturn = true;
   steeringAutoReturnRate = 0.9;
   steeringAutoReturnMaxSpeed = 10;
   steeringUseStrafeSteering = true;
   steeringStrafeSteeringRate = 0.1;
	
	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

	splash = VehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = VehicleFoamDropletsEmitter;
	splashEmitter[1] = VehicleFoamEmitter;
	splashEmitter[2] = VehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "Covered Wagon ";
	rideable = true;
		lookUpLimit = 0.65;
		lookDownLimit = 0.50;

	paintable = true;
   
   damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

   damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

   numDmgEmitterAreas = 1;

   initialExplosionProjectile = coveredwagonExplosionProjectile;
   initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 4000;

   finalExplosionProjectile = coveredwagonFinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now


   minRunOverSpeed    = 2;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 5;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1.2; //how hard a person you're running over gets pushed
};


datablock ShapeBaseImageData(HorseImage)
{
   shapeFile = "./horse.dts";
	emap = false;

	mountPoint = 7;
};

datablock ShapeBaseImageData(Horse2Image : HorseImage)
{
	mountPoint = 8;
};

function horsespeedCheck(%obj)
{
	//return;
	if(!isObject(%obj))
		return;

	%speed = vectorLen(%obj.getVelocity());
	if(%speed < 1)
	{
		if(%obj.hwalk !$= "stop")
		{
			%obj.stopThread(0);
			%obj.hwalk = "stop";
		}
	}
	else
	{
		if(%obj.hwalk !$= "walk")
		{
			%obj.playThread(0,walk);
			%obj.hwalk = "walk";
		}
	}

	schedule(2000,0,"horsespeedCheck",%obj);
   
}

function CoveredWagonVehicle::onAdd(%this,%obj)
{
	parent::onadd(%this,%obj);
	%obj.mountImage(HorseImage,1);
	%obj.mountImage(Horse2Image,2);
	
	%obj.mountable = true;
	
	%obj.setWheelTire(0, coveredwagonhorsetire);
	%obj.setWheelTire(1, coveredwagonhorsetire);
	%obj.setWheelTire(2, coveredwagontire);
	%obj.setWheelTire(3, coveredwagontire);
	%obj.setWheelTire(4, coveredwagontire);
	%obj.setWheelTire(5, coveredwagontire);

	%obj.setWheelSpring(0, coveredwagonspring);
	%obj.setWheelSpring(1, coveredwagonspring);
	%obj.setWheelSpring(2, coveredwagonspring);
	%obj.setWheelSpring(3, coveredwagonspring);
	%obj.setWheelSpring(4, coveredwagonspring);
	%obj.setWheelSpring(5, coveredwagonspring);
	
	%obj.setWheelSteering(0,1);
	%obj.setWheelSteering(1,1);
	%obj.setWheelSteering(2,0);
	%obj.setWheelSteering(3,0);
	%obj.setWheelSteering(4,0);
	%obj.setWheelSteering(5,0);

	%obj.setWheelPowered(0,true);
    %obj.setWheelPowered(1,true);
	%obj.setWheelPowered(2,true);
	%obj.setWheelPowered(3,true);
    %obj.setWheelPowered(4,true);
	%obj.setWheelPowered(5,true);
	
	 horsespeedCheck(%obj);

	 %obj.cover = 1;
	 %obj.frame = 1;
}

function serverCmdTogWagonCover(%client)
{
	%player = %client.Player;
	%wagon = %player.getControlObject();

	if(isObject(%player) && isObject(%wagon) && %wagon.dataBlock $= "coveredWagonVehicle")
	{
		if(%wagon.cover == 1)
		{
			%wagon.cover = 0;
			%wagon.hideNode(cover);
		}
		else
		{
			%wagon.cover = 1;
			%wagon.unhideNode(cover);

			if(%wagon.frame == 0)
			{
				%wagon.frame = 1;
				%wagon.unhideNode(coversupport);
			}
		}
	}
}

function serverCmdTogWagonFrame(%client)
{
	%player = %client.Player;
	%wagon = %player.getControlObject();

	if(isObject(%player) && isObject(%wagon) && %wagon.dataBlock $= "coveredWagonVehicle")
	{
		if(%wagon.frame == 1)
		{
			if(%wagon.cover == 1)
			{
				%wagon.cover = 0;
				%wagon.hideNode(cover);
			}

			%wagon.frame = 0;
			%wagon.hideNode(coversupport);
		}
		else
		{
			%wagon.frame = 1;
			%wagon.unhideNode(coversupport);
		}
	}
}



